/*
  - RUTA: /parrillaIntranet
  - PARRILLA {{channel}} - INTRANETS
  - MUESTRA PROGRAMACION E IMPRESION
*/	
<template>
    <div class="style_Programs">
      <header style="margin: 10rem 1rem 3rem">
        <ReturnButton :spanTitle="2" title="Regresar" v-on:clickEvent="returnPage" style="margin-bottom:2.5rem"/>
      </header>
      <!-- COMPONENTE TITULO -->
     <div class="margin-title-grid">
			<app-title :Title="`PARRILLA ${chanelTransmission} - INTRANET`" bgColor="background-color: #4A4A4A !important"> </app-title>
		</div>
      <el-main>
          <h1 class="title-Schedule">Programación de la {{dateString}}</h1>
      <!-- Fecha y botones -->
			<el-row class="margin-date-btn-in-grid-style" type="flex" justify="space-between">
				<div class="flex-content">
					<div style="margin-right: 50px;">
						<p style="margin-top: 0.6rem;" class="title">{{dateString}}</p>
					</div>
					<el-date-picker
						class="date-head flex element-bloq-center"
						v-model="dateSearch"
						type="date"
						format="dd/MM/yyyy"
						value-format="timestamp"
						placeholder="Escoja una semana"
						@change="setWeek">
					</el-date-picker>
				</div>
				<div class="flex element-bloq-center">
                    <el-tooltip class="item" effect="dark" content="Imprimir" placement="bottom">
						<el-button @click="printPage" class="margin_l_35 btn_icons_p font-size-25" icon="icon-print" type="iconGrid" :disabled="isDisabledBtn"></el-button>
					</el-tooltip>

        	        <div v-if="styleBtnAproved.isShow == false" class="text-green margin_l_35 flex element-bloq-center">
						<i class="icon-check font-size-18" style="margin-right: 8px"></i>
						<p class="font-size-17 textBold"> APROBADO </p>
					</div>
					<div v-else>
						<p class="font-size-17 margin_l_35 flex text-red-color textBold"> PENDIENTE </p>
					</div>
				</div>
			</el-row>
			<div class="flex-content just-center">
				<!--Schedule-->
				<gridSchedule :hours="timeForDay" boxSyleBorder="box_style_border_left" borderSquare="box_style_border_left"/>
				<!--Content-->
				<div>
					<gridDays :haveRef="true" :days="generateDays()"/>
						
					<div class="grid-programs" ref="contenedor">
							<div v-for="(program, index) in orderByProgram" :key="index" class="grid-byProgram" :ref="`cell-${index}`" >
									<!-- _______ Header-Program ________ -->
									<div class="flex justify position-z-index">
										<div class="programDuration" :class="[durationProgramHeader(program.programByDay)]">
											<span>{{calculateScheduleHours(program.programPrincipal.scheduleStartHour, program.programPrincipal.scheduleStartMin)}}</span>
											-
											<span>{{calculateScheduleHours(program.programPrincipal.scheduleEndHour, program.programPrincipal.scheduleEndMin)}}</span>
										</div>
									</div>

									<div>
                    <!--  program.programPrincipal.materialType == 'Producción Nacional'? 'text-orange' : 'text-blue-color',  -->
										<div class="principalTitle work-break text-blue-color" v-bind:class="[`${durationProgramTitle(program)}`]" v-if="program.programPrincipal.typeOfContent !== 'Largometrajes' &&  program.programPrincipal.typeOfContent !== 'LARGOMETRAJES'">
                      <span> {{ program.programPrincipal.programTitle }} </span>
                       <!--  TEMPORADA -->
                      <span v-bind:class="[`${ durationProgramSeason(program.programPrincipal)}`]"  v-if="program.programPrincipal.season !== '' && program.programPrincipal.season !== null" class="text-ligth blueColor"> ({{program.programPrincipal.season}}° TEMPORADA ) </span>
                   </div>
										<!-- Titulo del programa para largometrajes -->
                    <div v-else :class="[sizeOfDuration(program.programPrincipal)]">
                      <p class="text-orange principalTitle work-break" :class="[durationProgramTitleLargometraje(program.programPrincipal), sizeOfDuration(program.programPrincipal)]">"{{ program.programPrincipal.programTitle }}"</p>
                      <p class="principalTitle text-blue-color work-break" :class="[durationProgramTitle(program)]"> {{ program.programPrincipal.materialTitle }} 
                          <!-- _________ Clasificación __________ -->
                        <span :class="[isClassificationFilmsShow(program.programPrincipal), (program.programPrincipal.materialType == 'Producción Nacional')?'text-marron':'text-red']" class="padding-left-5" v-if=" program.programPrincipal.classification !== ''">{{ isHaveContent(program.programPrincipal.classification) }} </span>
                      </p>
                    </div>
                    <div class="principalTitle" :class="[sizeOfDuration(program.programPrincipal)]">
                      <!-- _________Nota general__________ -->
                      <div style="margin-top: 1rem" v-if="program.programPrincipal.generalNoteBoss && program.programPrincipal.generalNoteBoss !== ''" class="flex-content justify-content-center general-note-style work-break" v-html="program.programPrincipal.generalNoteBoss"> <br></div>
				      <div style="margin-top: 1rem" v-if="program.programPrincipal.generalNote && program.programPrincipal.generalNote !== ''" class="flex-content justify-content-center general-note-style work-break" v-html="program.programPrincipal.generalNote"> <br></div>
                    </div>			
									</div>
									<div class="boxAllDays">
											<!-- tengo mas de un dia -->
											<div class="boxByDay" v-for="(day, index) in program.programByDay" :key="index" :style="`grid-column: ${index+1} / span 1; backgroundColor: ${day.bgColorByProgram}`" >
												<div class="contentBoxByChapter" :class="[day.chapters.length >= 3 ? 'rezise-box' : '']">
                                                    <div v-if="day.nota && day.nota !== '' " class="note work-break padding-0-10 font-size-14" v-html="day.nota" ></div>
                                                    <div v-if="day.noteDay && day.noteDay !== '' " class="note work-break padding-0-10 font-size-14" v-html="day.noteDay" ></div>

                                                    <!-- <div v-if="day.nota && day.nota !== '' " class="note work-break padding-0-10 font-size-14" v-html="day.nota" ></div>
                                                    <div v-if="day.noteDay && day.noteDay !== '' " class="note work-break padding-0-10 font-size-14" v-html="day.noteDay" ></div>
                                                    <div v-if="day.generalNoteBoss && day.generalNoteBoss !== '' " class="note work-break padding-0-10 font-size-14 text-white" v-html="day.generalNoteBoss" ></div>
                                                    <div v-if="day.generalNote && day.generalNote !== '' " class="note work-break padding-0-10 font-size-14 text-white" v-html="day.generalNote" ></div> -->
                                                    	  
													<div class="boxByChapter flex-content justify-content-space" v-for="(chapter, i) in day.chapters" :key="i">
														<div style="width: auto; max-width: 100%;" class="boxDataByChapter">
                                                             <!-- __________Estado___________ -->
                                                            <!-- <div>
                                                                <span class="statusByChapterText" :class="[sizeChapterStatus(program.programPrincipal)]"> 
                                                                <span v-if="chapter.rerun" class="text-blue">Rerun </span> <span v-if="chapter.rerun && chapter.estreno">-</span>
                                                                <span v-if="chapter.estreno" class="text-red"> Estreno </span> 
                                                                <span v-if="chapter.ongoing" class="text-celeste"> (ONGOING)</span> 
                                                                <span v-if="day.chapters.length>1 && day.chapters.length-1 !== i">/</span>
                                                                </span>
                                                            </div> -->
                                                            <div v-if="program.programPrincipal.materialHasChapter == 'No' && program.programPrincipal.typeOfContent == 'Largometrajes' || program.programPrincipal.typeOfContent == 'LARGOMETRAJES'" >
                                                                <p  class="text-blue-color" style="display: inline-block; font-weight: 400; margin-left: 8px"> {{ program.programPrincipal.firstActor }} </p>
                                                                <p  class="text-blue-color" style="display: inline-block; font-weight: 400; margin-left: 8px"> {{ program.programPrincipal.secondActor }} </p>
                                                            </div>
														</div>
													</div>
												</div>	
											</div>
									</div>
							</div>
					</div>
					<gridDays :days="generateDays()"/>
				</div>
				<!--Schedule-->
				<gridSchedule :hours="timeForDay" boxSyleBorder="box_style_border_rigth" borderSquare="box_style_border_rigth"/>
			</div>
		</el-main>
	</div>
</template>

<script>
    import ReturnButton from '@/components/ReturnButton.vue'
    import Title from '@/components/Title.vue'
    import gridSchedule from '@/components/grid/gridSchedule'
    import gridDays from '@/components/grid/gridDays'
    // import gridProgram from '@/components/grid/gridProgram'
    import { getFirstDay } from '@/utils/calculateTime.js'
    import { padNmb, secondsToTime, stringToSeconds, getTime, recordArray, addingZerosToTheDay, convertToMinutes, conditionalDate, sortByHour, dayStartAndDayEnd, convertFormatDayForCrusses, convertHourDate, calculateHour } from '@/utils/calculateTimePrograms.js'
    // isHaveClassification, isHaveActors
    import { sizeLetttersAboutProgram, calculateSchedule, sizeLetttersAboutProgramCompare } from '@/utils/calculateSizeLetters.js'
    import { modelProgramByDay } from '@/utils/util.js'
    import { months } from '@/enums.js'
    import { HTTP } from '@/main.js'
    import { mapState } from 'vuex'

    export default {
        components: {
            ReturnButton,
            'app-title': Title,
            gridSchedule,
            gridDays,
            // gridProgram
        },
        data () {
            return {
                dateString: '',
                dateSearch: '',
                timeForDay: [],
                firstDay: '00',
                secondDay: '00',
                thirdDay: '00',
                fourthDay: '00',
                fifthDay: '00',
                sixthDay: '00',
                lastDay: '00',
                orderByProgram: [],
                chanelTransmission: this.$localStorage.get('channelTransmition'),
                dataAllWeek: [],
            }
        },
        sockets:{
            updateGridPreliminary(weeks){
			if(weeks.includes(this.dateString))
				this.getWeek(this.dateString);
            },
            programarParrillaRegular(weeks){
                if(weeks.includes(this.dateString))
                    this.getWeek(this.dateString);
            }
        },
        mounted(){
            let printView = false;
			let alturas = []
			let alturasImprimir=[]
			let alturasAux=[];
			for(let i=1; i<=288; i++){alturas.push['20px']};
			let templateRows = alturas.join(' ');
			const items = document.querySelectorAll('.grid-schedule');
			const boxes = document.querySelectorAll('.box_style');
			const grids = document.querySelectorAll('.grid-programs')
			boxes.forEach(box=>box.style.gridTemplateRows = templateRows)
			grids.forEach(grid=>grid.style.gridTemplateRows = templateRows)
			

			window.addEventListener('afterprint',()=>{
				console.log('luego de imprimir')
				printView = false;
				alturas = JSON.parse(JSON.stringify(alturasAux));
				templateRows = alturas.join(' ');
				boxes.forEach(box=>box.style.gridTemplateRows = templateRows)
				grids.forEach(grid=>grid.style.gridTemplateRows = templateRows)
			})

			window.addEventListener('beforeprint',()=>{
				console.log('antes de imprimir')
				printView = true;
				setTimeout(()=>{
					alturasAux = JSON.parse(JSON.stringify(alturas));
					alturas = alturas.map(altura=>Math.floor(parseInt(altura)/3)+'px')
					templateRows = alturas.join(' ');
					boxes.forEach(box=>box.style.gridTemplateRows = templateRows)
					grids.forEach(grid=>grid.style.gridTemplateRows = templateRows)
				},100)
				setTimeout(()=>{
					items.forEach(item=>{
						let currentStyle= item.getAttribute('style').split(';')[0];
						item.setAttribute('style',currentStyle);
					},100)
				})
				
			})

			var ro = new ResizeObserver( entries => {
				if(printView) return;
				for (let entry of entries) {
					const cr = entry.contentRect;
					const hg = parseInt(cr.height);
					let alturaUnica = parseInt(entry.target.style.gridRow);
					// console.log(alturaUnica);
					let calculateHeigth = Math.floor((Math.floor(hg)+3)/3)
					for(let j=alturaUnica -1; j<= alturaUnica+1; j++){
						alturas[j]= calculateHeigth+'px';
					}
					templateRows = alturas.join(' ');
					// console.log(templateRows);
					boxes.forEach(box=>box.style.gridTemplateRows = templateRows)
					grids.forEach(grid=>grid.style.gridTemplateRows = templateRows)
				}
			});

			items.forEach(item=>ro.observe(item))
        },
        methods: {
          	sizeChapterStatus(val) {
              const data = this.calculateTime(val)
              let time
              if(data <= '00:05:00') {
                time = 'font-size-11'
              } else if (data > '00:05:00' && data <= '00:15:00') {
                // letters-middle
                time = 'font-size-13'
              } else if(data > '00:15:00' && data <= '00:30:00') {
                // letters-normal 
                time = 'font-size-15'
              }  else if(data > '00:30:00' && data <= '01:00:00') {
                time = 'font-size-18'
              } else {
                time = 'font-size-20'
              }
              return time
            },
        	sizeOfDuration(value) {
              let response = this.calculateTime(value)
              return response <= '00:45:00' ? 'margin-0' : ''
            },
          	isClassificationFilmsShow(val) {
              const data = this.calculateTime(val)
              return data >= '01:00:00' ? 'textCollapse' : 'd-inline-block'
            },
            returnPage () {
							this.$router.push({ name: 'views'})
            },
            printPage() {
							sessionStorage.setItem('orderByProgram', JSON.stringify(this.orderByProgram))
							sessionStorage.setItem('allProgramsWithGrid', JSON.stringify(this.allProgramsWithGrid))
							sessionStorage.setItem('dateString', JSON.stringify(this.dateString))
							sessionStorage.setItem('firstDay', JSON.stringify(this.firstDay))
							sessionStorage.setItem('secondDay', JSON.stringify(this.secondDay))
							sessionStorage.setItem('thirdDay', JSON.stringify(this.thirdDay))
							sessionStorage.setItem('fourthDay', JSON.stringify(this.fourthDay))
							sessionStorage.setItem('fifthDay', JSON.stringify(this.fifthDay))
							sessionStorage.setItem('sixthDay', JSON.stringify(this.sixthDay))
							sessionStorage.setItem('lastDay', JSON.stringify(this.lastDay))
							this.$router.push({ name: 'viewPrintGeneral', params: {grid: 'intranet'}})
            },
            setWeek(){
                if (this.dateSearch === '' || this.dateSearch === null) { 
                    this.firstDayOfWeek = getFirstDay(new Date())
                    this.startDate = getFirstDay(new Date())
                    this.firstDay = this.firstDayOfWeek.getDate();
                    this.secondDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)).getDate()
                    this.thirdDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*2).getDate()
                    this.fourthDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*3).getDate()
                    this.fifthDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*4).getDate()
                    this.sixthDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*5).getDate()
                    this.lastDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*6).getDate()
                    this.endDate = new Date(this.startDate.setDate(this.startDate.getDate() + 6))  
                    this.month = months[this.firstDayOfWeek.getMonth()];
                    this.month2 = months[this.endDate.getMonth()];
                    this.year = this.firstDayOfWeek.getFullYear();
                    this.year2 = this.endDate.getFullYear();
                } else {
                    this.firstDayOfWeek = getFirstDay(new Date(this.dateSearch));
                    this.startDate = getFirstDay(new Date(this.dateSearch))
                    this.firstDay = this.firstDayOfWeek.getDate();
                    this.secondDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)).getDate()
                    this.thirdDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*2).getDate()
                    this.fourthDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*3).getDate()
                    this.fifthDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*4).getDate()
                    this.sixthDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*5).getDate()
                    this.lastDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*6).getDate()
                    this.endDate = new Date(this.startDate.setDate(this.startDate.getDate() + 6))
                    this.month = months[this.firstDayOfWeek.getMonth()];
                    this.month2 = months[this.endDate.getMonth()];
                    this.year = this.firstDayOfWeek.getFullYear();
                    this.year2 = this.endDate.getFullYear();
                }

                if (this.month == this.month2 && this.year == this.year2  ) {
                    this.dateString = `Semana del ${this.firstDay} al ${this.lastDay} de ${this.month} del ${this.year}`
                } else if (this.month !== this.month2 && this.year == this.year2 ) {
                    this.dateString = `Semana del ${this.firstDay} de ${this.month} al ${this.lastDay} de ${this.month2} del ${this.year}`
                } else if (this.month !== this.month2 && this.year !== this.year2) {
                    this.dateString = `Semana del ${this.firstDay} de ${this.month} del ${this.year} al ${this.lastDay} de ${this.month2} del ${this.year2}`
                }
            },
            formatedArray() {
                const b = recordArray("05:30:00", "00:15:00", 'sum', 74).concat(recordArray("00:15:00", "00:15:00", 'sum', 19))
                const c = b.unshift("05:16:00")
                const d = b.map((e) => e.slice(0, 5))
                return d
            },
            generateDays() {
                const days = [
                    {
                        name: 'Lunes',
                        number: addingZerosToTheDay(this.firstDay),
                    },
                    {
                        name: 'Martes',
                        number: addingZerosToTheDay(this.secondDay),
                    },
                    {
                        name: 'Miercoles',
                        number: addingZerosToTheDay(this.thirdDay),
                    },
                    {
                        name: 'Jueves',
                        number: addingZerosToTheDay(this.fourthDay),
                    },
                    {
                        name: 'Viernes',
                        number: addingZerosToTheDay(this.fifthDay),
                    },
                    {
                        name: 'Sábado',
                        number: addingZerosToTheDay(this.sixthDay),
                    },
                    {
                        name: 'Domingo',
                        number: addingZerosToTheDay(this.lastDay),
                    }
                ]
                return days
            },
            async getWeek (weekSelect) {
              this.orderByProgram = []
              this.idOfPrograms = []
              const responseText = 'Week not found'
              const responseHTTP = await HTTP.post('grid/filterWeek',{week:weekSelect});
			  const coincidence = responseHTTP.data.ok? responseHTTP.data.grid : responseText;

              if(coincidence && coincidence !== responseText) {
                this.orderByProgram = []
                const { programs, approvedWeek } = coincidence
                this.allProgramsWithGrid = coincidence
                this.dataAllWeek = coincidence
                if(approvedWeek) {
                  
                  // FILTRO POR CANAL DE TRANSMISION
                  let isTrue = false
                  let programsByChannel = []
                  programs.map((program)=>{
                    if(program.refProgram.checkedChanels.length > 0){
                        program.refProgram.checkedChanels.map((channel)=> {
                            if(channel.toLowerCase() == this.chanelTransmission.toLowerCase()){
                                programsByChannel.push(program)
                            }
                        })
                    } else {
                      programsByChannel.push(program)
                    }
                  })
                  // RECORRE LA DATA QUE TRAE LA RESPUESTA
                  programsByChannel.map((program)=>{
                      const {refProgram: {_id}} = program

                      const object = {
                          programPrincipal: this.modelPrincipalProgram(program),
                          programByDay: [modelProgramByDay(program)]
                      }

                      if(this.idOfPrograms.includes(_id) == false){
                          // INSERTA LOS PROGRAMAS SI SUS ID'S NO HAN SIDO INSERTADOS ANTERIORMENTE
                          this.idOfPrograms.push(_id)
                          this.orderByProgram.push(object)
                      } else {
                          const {refProgram: {codeDays}} = program

                          let arrSamePrograms = []
                          this.orderByProgram.map((program, index)=>{
                              if(program.programPrincipal._id == _id){
                                  arrSamePrograms.push(index)
                              }
                          })
                          
                          let daySelected = this.getDayCode(program.completeDate)
                          
                          let addToProgram = false
                          //RECORRE EL ARRAY DE PROGRAMAS QUE SE HAN CREADO PERO QUE PERTENECEN AL MISMO PROGRAMA
                          for(let i=0; i<arrSamePrograms.length; i++){
                              let programSelected = this.orderByProgram[arrSamePrograms[i]]
                              let daysSaved = []
                              //GUARDA EN UN ARRAY LOS DIAS QUE SE HAN GUARDADO EN EL PROGRAMA
                              programSelected.programByDay.map((programDay)=>{
                                  const day = programDay.completeDate
                                  const daySaved = this.getDayCode(day)
                                  daysSaved.push(daySaved)
                              })
                              //RECORRE LOS DIAS DEL PROGRAMA 
                              codeDays.map((day, index)=>{
                                  //VERIFICA EL DIA SELECCIONADO
                                  if(day == daySelected){
                                      //SI ES DOMINGO SE CAMBIA A 8 PORQUE CON EL 1 NO VALIDA CORRECTAMENTE
                                      daySelected = (daySelected == 1)? 8: daySelected
                                      //VALIDA SI EL DIA SELECCIONADO ES CORRELATIVO EN EL ARRAY DE DIAS DEL PROGRAMA
                                      if(codeDays.includes(daySelected-1) || codeDays.includes(daySelected+1)){
                                          //RECORRE LOS DIAS DEL PROGRAMA YA INGRESADOS
                                          daysSaved.map((savedDay)=>{
                                              //VERIFICA QUE EL DIA SELECCIONADO SEA CORRELATIVO A LOS DIAS QUE YA ESTAN INGRESADOS
                                              
                                              if(savedDay == (daySelected-1) || savedDay ==  (daySelected+1)){
                                                  // VERIFICA QUE LOS DIAS CONTENGAN EL MISMO HORARIO
                                                  const indexArrProgram = programSelected.programByDay.length -1
                                                  const lastProgram = programSelected.programByDay[indexArrProgram]
                                                  const programByDay = modelProgramByDay(program)
                                                  
                                                  let lastProgramTimeStart = convertToMinutes(lastProgram.scheduleStartHour, lastProgram.scheduleStartMin)
                                                  let lastProgramTimeEnd = convertToMinutes(lastProgram.scheduleEndHour, lastProgram.scheduleEndMin)

                                                  let programSelectedTimeStart = convertToMinutes(programByDay.scheduleStartHour, programByDay.scheduleStartMin)
                                                  let programSelectedTimeEnd = convertToMinutes(programByDay.scheduleEndHour, programByDay.scheduleEndMin)
                                                  
                                                  if((lastProgramTimeStart == programSelectedTimeStart) && (lastProgramTimeEnd == programSelectedTimeEnd)){
                                                      addToProgram = true
                                                      programSelected.programByDay.push(modelProgramByDay(program))
                                                  } else {
                                                      addToProgram = false
                                                  }
                                                  
                                              }
                                          })
                                      }
                                  }
                              })
                          }
                          //AGREGA COMO NUEVO PROGRAMA SI NO ES UN DIA CORRELATIVO
                          if(addToProgram == false){
                              this.orderByProgram.push(object)
                          }

                      }
                  })
                }
              }
              this.orderByProgram = sortByHour(this.orderByProgram)
              this.fillingGrid(this.orderByProgram)
          // })
          // .catch(err => console.log(err))
            },
            modelPrincipalProgram (program) {
                let exitMaterialReferencia = program.materialReferencia ? program.materialReferencia.typeOfContent : ''
			    let conditionalTypeOfContent = program.typeOfContent ? program.typeOfContent : exitMaterialReferencia
            	const programPrincipal = {
                _id: program.refProgram._id,
                arrCheckCrosses: program.refProgram.arrCheckCrosses,
                checkedChanels: program.refProgram.checkedChanels,
                checkedSignals:program.refProgram.checkedSignals ,
                codProgram: program.refProgram.codProgram,
                codeDays: program.refProgram.codeDays,
                geminisCode: program.refProgram.geminisCode,
                programTitle: program.refProgram.programTitle,
                scheduleEndHour: program.scheduleEndHour,
                scheduleEndMin: program.scheduleEndMin,
                scheduleStartHour: program.scheduleStartHour,
                scheduleStartMin: program.scheduleStartMin,
                transmissionDays: program.refProgram.transmissionDays,
                classification: program.classification,
                isTemporada: program.isTemporada,
                isClasification: program.isClasification,
                clasificationColor: program.clasificationColor,
                seasonColor: program.seasonColor,
                isUnitPrice: program.isUnitPrice,
                unitPriceColor: program.unitPriceColor,
                generalNote: program.generalNote,
                IsCodProvider: program.IsCodProvider,
                providerCode: program.providerCode,
                transmissionDaysDescription: dayStartAndDayEnd(program.refProgram.transmissionDays),
                typeOfContent: conditionalTypeOfContent,
                materialTitle: program.materialTitle,
                materialHasChapter: program.materialHasChapter,
                materialType: program.materialType,
                firstActor: program.firstActor,
                secondActor: program.secondActor,
                unitPrice: program.unitPrice,
                season: program.season,
                stringMaterialType: program.stringMaterialType,
                codeFeatureFilm: program.codeFeatureFilm,
                materialReferencia: program.materialReferencia,
                material: program.material,
                programDate: program.programDate
              }
                // const {refProgram, material, isTemporada, isClasification, clasificationColor, seasonColor, isUnitPrice, unitPriceColor, generalNote, IsCodProvider, providerCode, scheduleEndHour, scheduleEndMin, scheduleStartHour, scheduleStartMin} = program
                // const {_id, arrCheckCrosses, checkedChanels, checkedSignals, codProgram, codeDays, geminisCode, programTitle, transmissionDays} = refProgram
                // const programPrincipal = {
                //     _id,
                //     arrCheckCrosses,
                //     checkedChanels,
                //     checkedSignals,
                //     codProgram,
                //     codeDays,
                //     geminisCode,
                //     programTitle,
                //     scheduleEndHour,
                //     scheduleEndMin,
                //     scheduleStartHour,
                //     scheduleStartMin,
                //     transmissionDays,
                //     material,
                //     isTemporada,
                //     isClasification,
                //     clasificationColor,
                //     seasonColor,
                //     isUnitPrice,
                //     unitPriceColor,
                //     generalNote,
                //     IsCodProvider,
                //     providerCode,
                //     transmissionDaysDescription: dayStartAndDayEnd(transmissionDays)
                // }
                return programPrincipal
            },
            transmissionDays(val) {
                if(val && val.length > 1) {
				const counter = val.length
				const connect = val[0] == 'Lunes' ? 'a' : 'y'
				const counterCondicional = connect == 'a' ? 5 : 2
				const text = `${val[0]} ${connect} ${val[counter-1]}`
                    return {
                        text,
                        value: counterCondicional
                    }
                } else if(val && val.length == 1) {
                    return {
                        text: val[0],
                        value: 1
                    }
                }
            },
            // modelProgramByDay(program) {
            //     const {chapters, dailyCuttingProgram, crushedPrograms, replacementPrograms, isShowTemporadas, programGridTitle, dailyProgramDate, completeDate, scheduleStartHour, scheduleStartMin, scheduleEndHour, scheduleEndMin, materialTitle, codMaterial, material, refProgram, materialReferencia, programDate, geminisCodeProgram, IsCap, EstTemp, Estado, bgColorByProgram, chapterColor, seasonStateColor, stateChapterColor, rerunChapterColor, nota, isUnitPrice, unitPriceColor, IsCodProvider, codProviderColor, IsPricePass, pricePassColor, generalNote} = program
            //     const programByDay = {
            //         chapters, dailyCuttingProgram, crushedPrograms, replacementPrograms, isShowTemporadas, programGridTitle, dailyProgramDate, completeDate, scheduleStartHour, scheduleStartMin, scheduleEndHour, scheduleEndMin, materialTitle, codMaterial, material, refProgram, materialReferencia, programDate, geminisCodeProgram, IsCap, EstTemp, Estado, bgColorByProgram, chapterColor, seasonStateColor, stateChapterColor, rerunChapterColor, nota, isUnitPrice, unitPriceColor, IsCodProvider, codProviderColor, IsPricePass, pricePassColor, generalNote
            //     }
            //     return programByDay
            // },
            getDayCode (day){
                let daySelected = day.split(' ')[0]
                let dayCode = ''
                switch(daySelected){
                    case 'Lunes':
                        dayCode = 2
                    break;
                    case 'Martes':
                        dayCode = 3
                    break;
                    case 'Miércoles':
                        dayCode = 4
                    break;
                    case 'Jueves':
                        dayCode = 5
                    break;
                    case 'Viernes':
                        dayCode = 6
                    break;
                    case 'Sábado':
                        dayCode = 7
                    break;
                    case 'Domingo':
                        dayCode = 1
                    break;
                }
                return dayCode
            },
            fillingGrid (data) {
                let programs = data
                this.contentHtml = ''
                programs.map((program, index) => {
                  let template = ''
                  const nameProgram = program.programPrincipal.programTitle	
                  const arrDays = program.programByDay.map((e)=> (this.getDayCode(e.completeDate) == 1)?8:this.getDayCode(e.completeDate))

                  const daysInOrder = arrDays.sort()

                  let hourStart = program.programPrincipal.scheduleStartHour
                  let hourEnd = program.programPrincipal.scheduleEndHour
                  let minEnd = program.programPrincipal.scheduleEndMin
                  let minStart = program.programPrincipal.scheduleStartMin

                  if (hourStart <5 ) {
                    hourStart = Number(hourStart) + 24
                  }
                  else if (hourStart == 5 && hourEnd !== 5 && minStart != 16 && minEnd == 16 ) {
                    hourStart = Number(hourEnd) + 24
                  }
                  
                  if (hourEnd <5) {
                    hourEnd = Number(hourEnd) + 24
                  } 
                  else if (hourEnd == 5 && minEnd<=16) {
                    hourEnd = Number(hourEnd) + 24
                  }

                  const totalMinutesStart = (Number(hourStart)*60) + Number(program.programPrincipal.scheduleStartMin)
                  const totalMinutesEnd = (Number(hourEnd)*60) + Number(minEnd)

                  let initGrid = Math.round(totalMinutesStart/5 - 63.2)
                  let finalGrid = Math.round(totalMinutesEnd/5 - 63.2)
          
                  const concatGrid = (initGrid+1) +' / '+ (daysInOrder[0]-1) + ' / span '+ (finalGrid - initGrid) + ' / ' + (daysInOrder[(daysInOrder.length)-1])

                  template = `<div class="grid-programsByDay" style="grid-area: ${concatGrid};">
                                  ${nameProgram}
                              </div>`
                  this.contentHtml += template

                  let divObj = 'cell-'+index
                  this.$refs[divObj] && this.$refs[divObj][0] ? this.$refs[divObj][0].style.gridArea = concatGrid : ''
                 })
            },
            calculateTime(val) {
               const {scheduleStartHour, scheduleStartMin, scheduleEndHour, scheduleEndMin, programTitle} = val
                
                let timeStartProgramCardsData = convertFormatDayForCrusses( convertHourDate(val.programDate, scheduleStartHour, scheduleStartMin), val.programDate, 'start' )
                let timeEndProgramCardsData = convertFormatDayForCrusses( convertHourDate(val.programDate, scheduleEndHour, scheduleEndMin), val.programDate, 'end' )
                
                let timeStart = new Date(String(timeStartProgramCardsData)).getTime()
                let timeEnd = new Date(String(timeEndProgramCardsData)).getTime()
                let hourDiff = timeEnd - timeStart
                let secDiff = hourDiff / 1000
                let minDiff = hourDiff / 60 / 1000
                let hDiff = hourDiff / 3600 / 1000
                let result = {}
                result.hours = Math.floor(hDiff)
                result.minutes = minDiff - 60 * result.hours
                
                let response =  `${calculateHour(String(result.hours))}:${calculateHour(String(result.minutes))}:00`
                return response
            },
            durationProgramHeader(program) {
                const {programTitle} = program[0]
                const data = this.calculateTime(program[0])
                let conditional = program.length == 1 ? true : false
                let time
                if(conditional && (data <= '00:10:00'|| data == '00:00:00' )) {
                    return programTitle && programTitle.length <= 14 ? 'font-size-10 p-0' : 'hidden'
                } else {
                    if(data < '00:10:00') {
                        time = programTitle && programTitle.length >= 14 ? 'hidden' : 'font-size-12 p-0'
                    } else if(data >= '00:10:00' && data <= '00:15:00') {
                        time = 'font-size-14 p-0'
                    } else if (data > '00:15:00' && data <= '00:45:00') {
                        time = 'font-size-16 p-0'
                    } else {
                        time = 'font-size-17'
                    }
                    return time
                }
            },
            calculateScheduleHours(scheduleStartHour, scheduleStartMin) {
                return calculateSchedule(scheduleStartHour, scheduleStartMin)
            },
            durationProgramTitle(program) {
                // const data = this.calculateTime(val)
                // const {programTitle} = val
                // let time
                // if(data <= '00:05:00') {
                //     time = sizeLetttersAboutProgramCompare(programTitle, 'letters-small font-size-10', 'letters-small font-size-15 text-end' ,14)
                // } else if (data > '00:05:00' && data <= '00:15:00') {
                //     time = 'font-size-14 p-absolute t-0 font-weight-0'
                // } else if(data > '00:15:00' && data <= '00:30:00') {
                //     time = 'font-size-14 font-weight-0'
                // }  else if(data > '00:30:00' && data <= '01:00:00') {
                //     time = 'font-size-18'
                // } else {
                //     time = 'letters-big'
                // }
                // return time
                const data = this.calculateTime(program.programPrincipal)
                let conditional = program.programByDay.length == 1 ? true : false
                const {programTitle, materialTitle, typeOfContent} = program.programPrincipal
                let time
                if(conditional) {
                    let oneWord = materialTitle.split(' ')
                    if(oneWord.length == 1) {
                        if(typeOfContent == 'Largometrajes' || typeOfContent == 'LARGOMETRAJES') {
                            time = materialTitle.length >= 10 ? 'font-size-18' : 'font-size-22'
                        } else {
                            time = this.stylesForProgramTitle(data, conditional, programTitle)
                        }
                    } else {
                        time = this.stylesForProgramTitle(data, conditional, programTitle)
                    }
                } else {
                    time = this.stylesForProgramTitle(data, conditional, programTitle)
                }
                return time
            },
            stylesForProgramTitle(data, conditional, programTitle) {
                let time
                if(data <= '00:00:00' ) {
                    time = conditional ? sizeLetttersAboutProgramCompare(programTitle, 'font-size-15', 'font-size-18 text-end' ,14) : sizeLetttersAboutProgramCompare(programTitle, 'font-size-15', 'font-size-18' ,14)
                } else if(data <= '00:05:00') {
                    time = conditional ? sizeLetttersAboutProgramCompare(programTitle, 'letters-small font-size-10', 'letters-small font-size-15 text-end' ,14) : sizeLetttersAboutProgramCompare(programTitle, 'letters-small font-size-10', 'letters-small font-size-15' ,14)
                } else if (data > '00:05:00' && data <= '00:15:00') {
                    time = 'font-size-14 t-5 font-weight-0'
                } else if(data > '00:15:00' && data <= '00:30:00') {
                    // time = 'font-size-14 font-weight-0'
                    time = programTitle.length <= 14 ? 'font-size-14 font-weight-0' : 'font-size-14 font-weight-0 m-i-0'
                }  else if(data > '00:30:00' && data <= '01:00:00') {
                    time = 'font-size-18'
                } else {
                    time = 'font-size-24'
                }
                return time
            },
            durationProgramSeason (val) {
              const data = this.calculateTime(val)
              const {programTitle} = val
              let time
              if(data <= '00:05:00') {
                // time = sizeLetttersAboutProgramCompare(programTitle, 'letters-small font-size-10', 'letters-small font-size-15 text-end' ,14)
              } else if (data > '00:05:00' && data <= '00:15:00') {
                  time = 'size-letter-12 text-ligth blueColor'
              } else if(data > '00:15:00' && data <= '00:30:00') {
                  time = 'size-letter-12 text-ligth blueColor'
              }  else if(data > '00:30:00' && data <= '01:00:00') {
                  time = 'size-letter'
              } else {
                  time = 'f-16 text-ligth blueColor'
              }
              return time
            },
            durationProgramTitleLargometraje(val) {
                const {programTitle} = val
                const data = this.calculateTime(val)
                let time
                if(data <= '00:30:00') {
                    time = sizeLetttersAboutProgram(programTitle, 'font-size-8', 'size-10')
                }  else if(data > '00:30:00' && data <= '01:00:00') {
                    time = sizeLetttersAboutProgram(programTitle, 'size-10', 'font-size-11')
                } else {
                    time = 'letters-middle'
                }
                return time
            },
            isHaveActors(val) {
                let value, arr
                if(val && val.artisticInfo) {
                    let exitsActors = val.artisticInfo.length > 0 ? val.artisticInfo[0].mainActors : []
                    let counterActors = exitsActors.length
                    if(counterActors > 2) {
                        arr = [exitsActors[0], exitsActors[1]]
                    } else {
                        arr = exitsActors
                    }
                    value = arr
                }
                return value
            },
            isHaveContent(val) {
                let value
                if(val && val !== '') {
                    value = `(${val})`
                } else {
                    value = ''
                }
                return value
            }
        },
        created () {
            this.setWeek()
            this.timeForDay = this.formatedArray()
        },
        updated(){
            if(this.orderByProgram.length > 0){
                this.fillingGrid(this.orderByProgram)
            }
        },
        watch: {
            dateString: {
                handler(newVal, oldVal){
                    if(newVal !== ''){
                        this.getWeek(newVal)
                    }
                },
            }
        },
        computed: {
          isDisabledBtn () {
            return this.orderByProgram.length > 0 ? false : true
          },
         	styleBtnAproved() {
            let obj = {}
            if(this.orderByProgram.length > 0 && this.dataAllWeek.approvedWeek) {
              obj.name ='APROBADO'
              obj.status = true
              obj.isShow = false
            } else {
              obj.name ='APROBAR'
              obj.status = this.isDisabledBtn
              obj.isShow = true
            }
            return obj
          }
        }
    }
</script>